config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.kea.new
config etc/kea/kea.conf.new
config etc/kea/keactrl.conf.new
( cd usr/lib ; rm -rf libkea-cfgclient.so.3 )
( cd usr/lib ; ln -sf libkea-cfgclient.so.3.0.0 libkea-cfgclient.so.3 )
( cd usr/lib ; rm -rf libkea-dhcpsrv.so.7 )
( cd usr/lib ; ln -sf libkea-dhcpsrv.so.7.0.0 libkea-dhcpsrv.so.7 )
( cd usr/lib ; rm -rf libkea-asiodns.so.0 )
( cd usr/lib ; ln -sf libkea-asiodns.so.0.0.0 libkea-asiodns.so.0 )
( cd usr/lib ; rm -rf libkea-util-io.so )
( cd usr/lib ; ln -sf libkea-util-io.so.0.0.0 libkea-util-io.so )
( cd usr/lib ; rm -rf libkea-dhcp_ddns.so.1 )
( cd usr/lib ; ln -sf libkea-dhcp_ddns.so.1.0.2 libkea-dhcp_ddns.so.1 )
( cd usr/lib ; rm -rf libkea-cfgclient.so )
( cd usr/lib ; ln -sf libkea-cfgclient.so.3.0.0 libkea-cfgclient.so )
( cd usr/lib ; rm -rf libkea-dhcp_ddns.so )
( cd usr/lib ; ln -sf libkea-dhcp_ddns.so.1.0.2 libkea-dhcp_ddns.so )
( cd usr/lib ; rm -rf libkea-exceptions.so )
( cd usr/lib ; ln -sf libkea-exceptions.so.0.0.0 libkea-exceptions.so )
( cd usr/lib ; rm -rf libkea-eval.so.5 )
( cd usr/lib ; ln -sf libkea-eval.so.5.0.0 libkea-eval.so.5 )
( cd usr/lib ; rm -rf libkea-util.so.2 )
( cd usr/lib ; ln -sf libkea-util.so.2.0.1 libkea-util.so.2 )
( cd usr/lib ; rm -rf libkea-cryptolink.so.2 )
( cd usr/lib ; ln -sf libkea-cryptolink.so.2.0.0 libkea-cryptolink.so.2 )
( cd usr/lib ; rm -rf libkea-cryptolink.so )
( cd usr/lib ; ln -sf libkea-cryptolink.so.2.0.0 libkea-cryptolink.so )
( cd usr/lib ; rm -rf libkea-hooks.so )
( cd usr/lib ; ln -sf libkea-hooks.so.3.0.0 libkea-hooks.so )
( cd usr/lib ; rm -rf libkea-util-io.so.0 )
( cd usr/lib ; ln -sf libkea-util-io.so.0.0.0 libkea-util-io.so.0 )
( cd usr/lib ; rm -rf libkea-http.so.0 )
( cd usr/lib ; ln -sf libkea-http.so.0.0.0 libkea-http.so.0 )
( cd usr/lib ; rm -rf libkea-eval.so )
( cd usr/lib ; ln -sf libkea-eval.so.5.0.0 libkea-eval.so )
( cd usr/lib ; rm -rf libkea-dhcp++.so.5 )
( cd usr/lib ; ln -sf libkea-dhcp++.so.5.0.0 libkea-dhcp++.so.5 )
( cd usr/lib ; rm -rf libkea-threads.so )
( cd usr/lib ; ln -sf libkea-threads.so.1.0.0 libkea-threads.so )
( cd usr/lib ; rm -rf libkea-asiolink.so )
( cd usr/lib ; ln -sf libkea-asiolink.so.4.0.0 libkea-asiolink.so )
( cd usr/lib ; rm -rf libkea-dhcpsrv.so )
( cd usr/lib ; ln -sf libkea-dhcpsrv.so.7.0.0 libkea-dhcpsrv.so )
( cd usr/lib ; rm -rf libkea-process.so.0 )
( cd usr/lib ; ln -sf libkea-process.so.0.0.0 libkea-process.so.0 )
( cd usr/lib ; rm -rf libkea-exceptions.so.0 )
( cd usr/lib ; ln -sf libkea-exceptions.so.0.0.0 libkea-exceptions.so.0 )
( cd usr/lib ; rm -rf libkea-cc.so )
( cd usr/lib ; ln -sf libkea-cc.so.2.0.0 libkea-cc.so )
( cd usr/lib ; rm -rf libkea-dns++.so )
( cd usr/lib ; ln -sf libkea-dns++.so.0.1.1 libkea-dns++.so )
( cd usr/lib ; rm -rf libkea-cc.so.2 )
( cd usr/lib ; ln -sf libkea-cc.so.2.0.0 libkea-cc.so.2 )
( cd usr/lib ; rm -rf libkea-threads.so.1 )
( cd usr/lib ; ln -sf libkea-threads.so.1.0.0 libkea-threads.so.1 )
( cd usr/lib ; rm -rf libkea-hooks.so.3 )
( cd usr/lib ; ln -sf libkea-hooks.so.3.0.0 libkea-hooks.so.3 )
( cd usr/lib ; rm -rf libkea-log.so.3 )
( cd usr/lib ; ln -sf libkea-log.so.3.0.0 libkea-log.so.3 )
( cd usr/lib ; rm -rf libkea-stats.so.1 )
( cd usr/lib ; ln -sf libkea-stats.so.1.0.0 libkea-stats.so.1 )
( cd usr/lib ; rm -rf libkea-process.so )
( cd usr/lib ; ln -sf libkea-process.so.0.0.0 libkea-process.so )
( cd usr/lib ; rm -rf libkea-dhcp++.so )
( cd usr/lib ; ln -sf libkea-dhcp++.so.5.0.0 libkea-dhcp++.so )
( cd usr/lib ; rm -rf libkea-http.so )
( cd usr/lib ; ln -sf libkea-http.so.0.0.0 libkea-http.so )
( cd usr/lib ; rm -rf libkea-dns++.so.0 )
( cd usr/lib ; ln -sf libkea-dns++.so.0.1.1 libkea-dns++.so.0 )
( cd usr/lib ; rm -rf libkea-asiodns.so )
( cd usr/lib ; ln -sf libkea-asiodns.so.0.0.0 libkea-asiodns.so )
( cd usr/lib ; rm -rf libkea-log.so )
( cd usr/lib ; ln -sf libkea-log.so.3.0.0 libkea-log.so )
( cd usr/lib ; rm -rf libkea-asiolink.so.4 )
( cd usr/lib ; ln -sf libkea-asiolink.so.4.0.0 libkea-asiolink.so.4 )
( cd usr/lib ; rm -rf libkea-util.so )
( cd usr/lib ; ln -sf libkea-util.so.2.0.1 libkea-util.so )
( cd usr/lib ; rm -rf libkea-stats.so )
( cd usr/lib ; ln -sf libkea-stats.so.1.0.0 libkea-stats.so )
